//AB/ Project Customer mailmerge example 1
//AB/   Object prj is a View_Project
//AB/     Set ProjectName to "Customer mailmerge example 1"
//AB/     Set ProjectFileName to "Custmm1.vw"

// Project Object Structure
//   Customer_mm1 is a dbView
//     oMergeApp is a OLEApplication
//       oDocuments is a OLEDocuments
//         oDocument is a OLEDocument
//           oContent is a OLERange
//           oMailMerge is a OLEMailMerge
//             oDataSource is a OLEMailMergeDataSource
//     Customer_DD is a DataDictionary
//     Customer_Number is a dbForm
//     Customer_Name is a dbForm
//     CustTD is a dbTabDialog
//       Address_TP is a dbTabPage
//         Customer_Address is a dbForm
//         Customer_City is a dbForm
//         Customer_State is a dbComboForm
//         Customer_Zip is a dbForm
//         Customer_Phone_number is a dbForm
//         Customer_Fax_number is a dbForm
//         Customer_Email_address is a dbForm
//       Balances_TP is a dbTabPage
//         Customer_Credit_Limit is a dbForm
//         Customer_Purchases is a dbForm
//         Customer_Balance is a dbForm
//       Comments_TP is a dbTabPage
//         Customer_Comments is a dbEdit
//     MergeLetterButton is a Button

// Register all objects
Register_Object Address_TP
Register_Object Balances_TP
Register_Object Comments_TP
Register_Object Customer_Address
Register_Object Customer_Balance
Register_Object Customer_City
Register_Object Customer_Comments
Register_Object Customer_Credit_Limit
Register_Object Customer_DD
Register_Object Customer_Email_address
Register_Object Customer_Fax_number
Register_Object Customer_mm1
Register_Object Customer_Name
Register_Object Customer_Number
Register_Object Customer_Phone_number
Register_Object Customer_Purchases
Register_Object Customer_State
Register_Object Customer_Zip
Register_Object CustTD
Register_Object MergeLetterButton
Register_Object oContent
Register_Object oDataSource
Register_Object oDocument
Register_Object oDocuments
Register_Object oMailMerge
Register_Object oMergeApp


//AB/   AppBuild VIEW


  //AB-StoreTopStart
  Use vSelectFile.pkg
  //AB-StoreTopEnd

  //AB-IgnoreStart


  Use CUSTOMER.DD
  
  //AB-IgnoreEnd

  DEFERRED_VIEW Activate_Customer_mm1 FOR ;
  ;
  Object Customer_mm1 is a dbView

    //AB-StoreTopStart
    Set Help_id to CustomerViewHelpId
    
    // MailMerge application
    Object oMergeApp Is A OLEApplication
        Object oDocuments Is A OLEDocuments
            Object oDocument Is A OLEDocument
                object oContent is a OLERange
                end_object
                Object oMailMerge Is A OLEMailMerge
                    Object oDataSource Is A OLEMailMergeDataSource
                    End_Object
                End_Object // oMailMerge
            End_Object // oDocument
        End_Object // oDocuments
    End_Object // oMergeApp
    //AB-StoreTopEnd

    Set Label to "Customer mailmerge example 1"
    Set Size to 178 283
    Set Location to 6 22

    //AB-DDOStart

    Object Customer_DD is a Customer_DataDictionary
    End_Object    // Customer_DD

    Set Main_DD to (Customer_DD(self))
    Set Server to (Customer_DD(self))

    //AB-DDOEnd

    Object Customer_Number is a dbForm
      Entry_Item Customer.Customer_number
      Set Label to "Customer Number:"
      Set Size to 13 42
      Set Location to 5 72
      Set Label_Col_Offset to 2
      Set Label_Justification_Mode to jMode_Right
    End_Object    // Customer_Number

    Object Customer_Name is a dbForm
      Entry_Item Customer.Name
      Set Label to "Name:"
      Set Size to 13 186
      Set Location to 20 72
      Set Label_Col_Offset to 2
      Set Label_Justification_Mode to jMode_Right
    End_Object    // Customer_Name

    Object CustTD is a dbTabDialog
      Set Size to 105 265
      Set Location to 36 7
      Set Rotate_Mode to RM_Rotate
      Object Address_TP is a dbTabPage
        Set Label to "Address"
        Object Customer_Address is a dbForm
          Entry_Item Customer.Address
          Set Label to "Street Address:"
          Set Size to 13 180
          Set Location to 8 62
          Set Label_Col_Offset to 2
          Set Label_Justification_Mode to jMode_Right
        End_Object    // Customer_Address

        Object Customer_City is a dbForm
          Entry_Item Customer.City
          Set Label to "City/State/Zip:"
          Set Size to 13 84
          Set Location to 24 62
          Set Label_Col_Offset to 2
          Set Label_Justification_Mode to jMode_Right
        End_Object    // Customer_City

        Object Customer_State is a dbComboForm
          Entry_Item Customer.State
          Set Size to 13 32
          Set Location to 24 152
        End_Object    // Customer_State

        Object Customer_Zip is a dbForm
          Entry_Item Customer.Zip
          Set Size to 13 51
          Set Location to 24 191
        End_Object    // Customer_Zip

        Object Customer_Phone_number is a dbForm
          Entry_Item Customer.Phone_number
          Set Label to "Phone Number:"
          Set Size to 13 120
          Set Location to 39 62
          Set Label_Col_Offset to 2
          Set Label_Justification_Mode to jMode_Right
        End_Object    // Customer_Phone_number

        Object Customer_Fax_number is a dbForm
          Entry_Item Customer.Fax_number
          Set Label to "Fax Number:"
          Set Size to 13 120
          Set Location to 54 62
          Set Label_Col_Offset to 2
          Set Label_Justification_Mode to jMode_Right
        End_Object    // Customer_Fax_number

        Object Customer_Email_address is a dbForm
          Entry_Item Customer.Email_address
          Set Label to "E-Mail Address:"
          Set Size to 13 180
          Set Location to 69 62
          Set Label_Col_Offset to 2
          Set Label_Justification_Mode to jMode_Right
        End_Object    // Customer_Email_address

      End_Object    // Address_TP

      Object Balances_TP is a dbTabPage
        Set Label to "Balances"
        Object Customer_Credit_Limit is a dbForm
          Entry_Item Customer.Credit_limit
          Set Label to "Credit Limit:"
          Set Size to 13 48
          Set Location to 9 72
          Set Label_Col_Offset to 2
          Set Label_Justification_Mode to jMode_Right
        End_Object    // Customer_Credit_Limit

        Object Customer_Purchases is a dbForm
          Entry_Item Customer.Purchases
          Set Label to "Total Purchases:"
          Set Size to 13 48
          Set Location to 24 72
          Set Label_Col_Offset to 2
          Set Label_Justification_Mode to jMode_Right
        End_Object    // Customer_Purchases

        Object Customer_Balance is a dbForm
          Entry_Item Customer.Balance
          Set Label to "Balance Due:"
          Set Size to 13 48
          Set Location to 39 72
          Set Label_Col_Offset to 2
          Set Label_Justification_Mode to jMode_Right
        End_Object    // Customer_Balance

      End_Object    // Balances_TP

      Object Comments_TP is a dbTabPage
        Set Label to "Comments"
        Object Customer_Comments is a dbEdit
          Entry_Item Customer.Comments
          Set Size to 60 242
          Set Location to 15 9
        End_Object    // Customer_Comments

      End_Object    // Comments_TP

    End_Object    // CustTD

    Object MergeLetterButton is a Button

      //AB-StoreTopStart
      
      //AB-StoreTopEnd

      Set Label to "Merge Letters"
      Set Location to 145 7

      //AB-StoreStart
      procedure OnClick
          send DoMergeLetters
      end_procedure
      //AB-StoreEnd

    End_Object    // MergeLetterButton


    //AB-StoreStart
    
    function AmountNumberToString number nAmount returns string
        local string sAmount sCents
        local integer iPos
        movestr nAmount to sAmount
        trim sAmount to sAmount
        right sAmount to sCents 3
        pos "." in sCents to iPos
        if iPos eq 0 append sAmount ".00"
        if iPos eq 2 append sAmount "0"
        function_return sAmount
    end_function
    
    function CreateHeaderString returns string
        local string sHeaderString
        move "Name,Address,City,State,Zip,CreditLimit,Purchases,Balance" to sHeaderString
        function_return sHeaderString
    end_function // CreateHeaderString
    
    function CreateDataString returns string
        local string sName sAddress sCity sState sZip sCreditLimit sPurchases sBalance
        local string sDataString
        //
        trim Customer.Name to sName
        append sName '","'
        trim Customer.Address to sAddress
        append sAddress '","'
        trim Customer.City to sCity
        append sCity '","'
        trim Customer.State to sState
        append sState '","'
        trim Customer.Zip to sZip
        append sZip '","'
        get AmountNumberToString Customer.Credit_limit to sCreditLimit
        append sCreditLimit '","'
        get AmountNumberToString Customer.Purchases to sPurchases
        append sPurchases '","'
        get AmountNumberToString Customer.Balance to sBalance
        append sBalance '"'
        //
        move '"' to sDataString
        append sDataString sName sAddress sCity sState sZip sCreditLimit sPurchases sBalance
        //
        function_return sDataString
    end_function // CreateDataString
    
    procedure DoMergeLetters
        //
        if NOT (Current_Record(Server(self))) procedure_return
        //
        local integer hMergeApp hDocuments hDocument hContent hMailMerge hDataSource
        local integer iArg iCount iAppId bActive
        local string sHeaderString sDataString sDataSource
        local string sFilename sFolder sTempfile
        // be safe
        get_argument_size to iArg
        set_argument_size 32000
        //
        get CreateHeaderString to sHeaderString
        get CreateDataString to sDataString
        move "CustMmDs" to sDataSource
        //
        get_profile_string "WorkSpaces\Order" "DataPath" to sFolder
        trim sFolder to sFolder
        get vSelect_File "Word Documents|*.DOC" "Select Merge Document" sFolder ;
            to sFilename
        if sFilename eq "" procedure_return
        //
        move (oMergeApp(self)) to hMergeApp
        move (oDocuments(hMergeApp)) to hDocuments
        move (oDocument(hDocuments)) to hDocument
        move (oContent(hDocument)) to hContent
        move (oMailMerge(hDocument)) to hMailMerge
        move (oDataSource(hMailMerge)) to hDataSource
        //
        local LPDispatch lpDocs lpDoc lpWordApp lpMerge lpFields lpSource
        local LPDispatch lpAdd lpContent
        local OLEVariant lFilename lReadOnly lAddToRecentFiles lRouteDocument
        local OLEVariant lFormat lLinkToSource lPause lSaveChanges lCollapse
        local OLEVariant lOriginalFormat
        PutOLEVariantValue OLEwdCollapseEnd as OLE_VT_I4 to lCollapse
        PutOLEVariantValue false as OLE_VT_BOOL to lReadOnly
        PutOLEVariantValue false as OLE_VT_BOOL to lAddToRecentFiles
        PutOLEVariantValue true  as OLE_VT_BOOL to lLinkToSource
        PutOLEVariantValue false as OLE_VT_BOOL to lPause
        PutOLEVariantValue OLEwdOpenFormatText as OLE_VT_I4 to lFormat
        PutOLEVariantValue OLEwdDoNotSaveChanges as OLE_VT_I4 to lSaveChanges
        PutOLEVariantValue OLEwdWordDocument as OLE_VT_I4 to lOriginalFormat
        PutOLEVariantValue false as OLE_VT_BOOL to lRouteDocument
        //
        move (AttachActiveObject(hMergeApp)) to bActive
        if NOT bActive send CreateDispatch to hMergeApp
        // find the Documents Collection
        get GetApplicationDocuments of hMergeApp to lpDocs
        // attach the collection
        send AttachDispatch to hDocuments lpDocs
        // open a new document
        get DocumentsAdd of hDocuments OLE_VT_OPTIONAL OLE_VT_OPTIONAL to lpAdd
        // attach the document
        send AttachDispatch to hDocument lpAdd
        // find the range
        get GetDocumentContent of hDocument to lpContent
        // attach the range
        send AttachDispatch to hContent lpContent
        // write the header
        send RangeInsertAfter to hContent sHeaderString
        // start a new line
        send RangeInsertParagraphAfter to hContent
        // write the data
        send RangeInsertAfter to hContent sDataString
        // collapse the range
        send RangeCollapse to hContent lCollapse
        // release the range
        send ReleaseDispatch to hContent
        // save the document
        PutOLEVariantValue sDatasource as OLE_VT_BSTR to lFilename
        send DocumentSaveAs to hDocument lFilename lAddToRecentFiles
        // get the source data name
        get GetDocumentFullName of hDocument to sDatasource
        // close the document
        send DocumentClose to hDocument lSaveChanges lOriginalFormat lRouteDocument
        // release the document
        send ReleaseDispatch to hDocument
        // open the merge document document
        PutOLEVariantValue sFilename as OLE_VT_BSTR to lFilename
        get DocumentsOpen of hDocuments ;
            lFilename lReadOnly lAddToRecentFiles to lpDoc
        // attach the document
        send AttachDispatch to hDocument lpDoc
        // launch the application & execute
        get GetDocumentApplication of hDocument to lpWordApp
        if lpWordApp ne 0 begin
            get GetDocumentMailMerge of hDocument to lpMerge
            if lpMerge ne 0 begin
                //
                send AttachDispatch to hMailMerge lpMerge
                get GetMailMergeDataSource of hMailMerge to lpSource
                if lpSource ne 0 ;
                    send AttachDispatch to hDataSource lpSource
                else begin
                    error 900 "Invalid Data Source object."
                    procedure_return
                end
                //
                send MailMergeOpenDataSource to hMailMerge ;
                    sDatasource lFormat lLinkToSource lAddToRecentFiles
                send SetMailMergeDestination to hMailMerge OLEwdSendToNewDocument
                send MailMergeExecute to hMailMerge lPause
                //
                send ReleaseDispatch to hDataSource
                send ReleaseDispatch to hMailMerge
                // close the form letter document
                send DocumentClose to hDocument lSaveChanges lOriginalFormat lRouteDocument
                //
                send SetApplicationVisible to hMergeApp true
                //send ApplicationActivate to hMergeApp
                send SetApplicationWindowState to hMergeApp OLEwdWindowStateMaximize
            end
        end
        else ;
            error 900 "Invalid Application object"
        PutOLEVariantValue OLEwdDoNotSaveChanges as OLE_VT_I4 to lSaveChanges
        send ReleaseDispatch to hDocument
        send ReleaseDispatch to hDocuments
        send ReleaseDispatch to hMergeApp
        erasefile sDatasource
        set_argument_size iArg
    end_procedure
    //AB-StoreEnd

  CD_End_Object    // Customer_mm1


  //AB-StoreStart
  
  //AB-StoreEnd

//AB/   End_Object    // prj
